using System;
using System.Windows.Forms;
using System.Drawing;
	
namespace Test
{
	public class SysInfoPanel : Form
	{
		// - 
		Single xCol;
		int linespacing;
	
		public SysInfoPanel()
		{
			//   
			this.Text = "  ";
			this.BackColor = SystemColors.Window;
			this.ForeColor = SystemColors.WindowText;
			this.AutoScroll = true;//    
			//      
			this.AutoScrollMargin = new Size(10, 10);
	
			//  ,  
			Graphics gr = this.CreateGraphics();
			//   
			SizeF sizeF = gr.MeasureString(" ", Font);
			//    
			xCol = sizeF.Width 
				+ SysInfoStrings.MaxLabelWidth(gr, Font);
			linespacing = Font.Height;
	
			//    Panel
			Panel panel = new Panel();
			//       
			//      !!!
			panel.Parent = this;
			//     Paint 
			//     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			panel.Paint +=new PaintEventHandler(panel_Paint);
			//      
			// (       )
			panel.Location = Point.Empty;
			//        
			panel.Size = new Size(
				(int)Math.Ceiling(xCol + SysInfoStrings.MaxValueWidth(gr, Font)),
				(int)Math.Ceiling(linespacing * SysInfoStrings.Count));
			/*
			//      
			SizeF size_F = new SizeF(
				xCol + SysInfoStrings.MaxValueWidth(gr, Font),
				linespacing * SysInfoStrings.Count);
			panel.Size = Size.Ceiling(size_F);
			*/
	
			//      
			gr.Dispose();
		}
	
		private void panel_Paint(object sender, PaintEventArgs e)
		{
			Graphics gr = e.Graphics;
	
			//   ,    
			//    
			gr.Clear(Color.Yellow);
	
			SolidBrush brush = new SolidBrush(this.ForeColor);
			//   
			int count = SysInfoStrings.Count;
			//       
			String[] strArrayLabels = SysInfoStrings.Labels;
			String[] strArrayValues = SysInfoStrings.Values;
	
			//      Panel.       
			// ,    Panel    
			for(int i = 0; i < count; i++)
			{
				gr.DrawString(strArrayLabels[i],
					Font, brush, 0, i * linespacing);
				gr.DrawString(strArrayValues[i],
					Font, brush, xCol, i * linespacing);
			}
		}
	}
}
