using System;
using System.Windows.Forms;
using System.Drawing;
	
namespace Test
{
	public class SysInfoScroll : Form
	{
		// - 
		Single xCol;
		int linespacing;
	
		public SysInfoScroll()
		{
			//   
			this.Text = "   ";
			// this.BackColor = SystemColors.Window;
			BackColor = Color.MediumSpringGreen;
			this.ForeColor = SystemColors.WindowText;
	
			//  ,  
			Graphics gr = this.CreateGraphics();
			//   
			SizeF sizeF = gr.MeasureString(" ", Font);
			//    
			xCol = sizeF.Width 
				+ SysInfoStrings.MaxLabelWidth(gr, Font);
			linespacing = Font.Height;
	
			//   
			this.AutoScroll = true;//    
			//      
			this.AutoScrollMargin = new Size(10, 10);
			//     
			SizeF size_F = new SizeF(
				xCol + SysInfoStrings.MaxValueWidth(gr, Font),
				linespacing * SysInfoStrings.Count);
			//   
			this.AutoScrollMinSize = Size.Ceiling(size_F);
	
			//      
			gr.Dispose();
		}
	
		//    !!!
		protected override void OnPaint(PaintEventArgs e)
		{
			Graphics gr = e.Graphics;
			SolidBrush brush = new SolidBrush(this.ForeColor);
			//   
			int count = SysInfoStrings.Count;
			//       
			String[] strArrayLabels = SysInfoStrings.Labels;
			String[] strArrayValues = SysInfoStrings.Values;
	
			//       .   
			//     ,     
			Point point = this.AutoScrollPosition; //   
			for(int i = 0; i < count; i++)
			{
				gr.DrawString(strArrayLabels[i],
					Font, brush,
					point.X, point.Y + i * linespacing);
				gr.DrawString(strArrayValues[i],
					Font, brush, 
					point.X + xCol, point.Y + i * linespacing);
			}
	
			base.OnPaint (e);
		}
	}
}
