using System;
using System.Windows.Forms;
using System.Drawing;
	
namespace Test
{
	//  60   SystemInformation BCL
	public class SysInfoStrings
	{
		//   
		public static String[] Labels
		{
			get
			{
				return new String[]
				{
					"ArrangeDirection", 
					"ArrangeStartingPosition", 
					"BootMode", 
					"Border3DSize",
					"BorderSize", 
					"CaptionButtonSize", 
					"CaptionHeight", 
					"ComputerName", 
					"CursorSize", 
					"DbcsEnabled", 
					"DebugOS", 
					"DoubleClickSize", 
					"DoubleClickTime", 
					"DragFullWindows", 
					"DragSize", 
					"FixedFrameBorderSize", 
					"FrameBorderSize", 
					"HighContrast", 
					"HorizontalScrollBarArrowWidth", 
					"HorizontalScrollBarHeight", 
					"HorizontalScrollBarThumbWidth", 
					"IconSize", 
					"IconSpacingSize", 
					"KanjiWindowHeight", 
					"MaxWindowTrackSize", 
					"MenuButtonSize", 
					"MenuCheckSize", 
					"MenuFont", 
					"MenuHeight", 
					"MidEastEnabled", 
					"MinimizedWindowSize", 
					"MinimizedWindowSpacingSize", 
					"MinimumWindowSize", 
					"MinWindowTrackSize", 
					"MonitorCount", 
					"MonitorsSameDisplayFormat", 
					"MouseButtons", 
					"MouseButtonsSwapped", 
					"MousePresent", 
					"MouseWheelPresent", 
					"MouseWheelScrollLines", 
					"NativeMouseWheelSupport", 
					"Network", 
					"PenWindows", 
					"PrimaryMonitorMaximizedWindowSize", 
					"PrimaryMonitorSize", 
					"RightAlignedMenus", 
					"Secure", 
					"ShowSounds", 
					"SmallIconSize", 
					"ToolWindowCaptionButtonSize", 
					"ToolWindowCaptionHeight", 
					"UserDomainName", 
					"UserInteractive", 
					"UserName", 
					"VerticalScrollBarArrowHeight", 
					"VerticalScrollBarThumbHeight", 
					"VerticalScrollBarWidth", 
					"VirtualScreen", 
					"WorkingArea" 
				}; // End of Array property Labels
			} // End of get
		} // end of property Labels
	
		//   
		public static String[] Values
		{
			get
			{
				return new String[]
				{
					SystemInformation.ArrangeDirection.ToString(), 
					SystemInformation.ArrangeStartingPosition.ToString(), 
					SystemInformation.BootMode.ToString(), 
					SystemInformation.Border3DSize.ToString(),
					SystemInformation.BorderSize.ToString(), 
					SystemInformation.CaptionButtonSize.ToString(), 
					SystemInformation.CaptionHeight.ToString(), 
					SystemInformation.ComputerName.ToString(), 
					SystemInformation.CursorSize.ToString(), 
					SystemInformation.DbcsEnabled.ToString(), 
					SystemInformation.DebugOS.ToString(), 
					SystemInformation.DoubleClickSize.ToString(), 
					SystemInformation.DoubleClickTime.ToString(), 
					SystemInformation.DragFullWindows.ToString(), 
					SystemInformation.DragSize.ToString(), 
					SystemInformation.FixedFrameBorderSize.ToString(), 
					SystemInformation.FrameBorderSize.ToString(), 
					SystemInformation.HighContrast.ToString(), 
					SystemInformation.HorizontalScrollBarArrowWidth.ToString(), 
					SystemInformation.HorizontalScrollBarHeight.ToString(), 
					SystemInformation.HorizontalScrollBarThumbWidth.ToString(), 
					SystemInformation.IconSize.ToString(), 
					SystemInformation.IconSpacingSize.ToString(), 
					SystemInformation.KanjiWindowHeight.ToString(), 
					SystemInformation.MaxWindowTrackSize.ToString(), 
					SystemInformation.MenuButtonSize.ToString(), 
					SystemInformation.MenuCheckSize.ToString(), 
					SystemInformation.MenuFont.ToString(), 
					SystemInformation.MenuHeight.ToString(), 
					SystemInformation.MidEastEnabled.ToString(), 
					SystemInformation.MinimizedWindowSize.ToString(), 
					SystemInformation.MinimizedWindowSpacingSize.ToString(), 
					SystemInformation.MinimumWindowSize.ToString(), 
					SystemInformation.MinWindowTrackSize.ToString(), 
					SystemInformation.MonitorCount.ToString(), 
					SystemInformation.MonitorsSameDisplayFormat.ToString(), 
					SystemInformation.MouseButtons.ToString(), 
					SystemInformation.MouseButtonsSwapped.ToString(), 
					SystemInformation.MousePresent.ToString(), 
					SystemInformation.MouseWheelPresent.ToString(), 
					SystemInformation.MouseWheelScrollLines.ToString(), 
					SystemInformation.NativeMouseWheelSupport.ToString(), 
					SystemInformation.Network.ToString(), 
					SystemInformation.PenWindows.ToString(), 
					SystemInformation.PrimaryMonitorMaximizedWindowSize.ToString(), 
					SystemInformation.PrimaryMonitorSize.ToString(), 
					SystemInformation.RightAlignedMenus.ToString(), 
					SystemInformation.Secure.ToString(), 
					SystemInformation.ShowSounds.ToString(), 
					SystemInformation.SmallIconSize.ToString(), 
					SystemInformation.ToolWindowCaptionButtonSize.ToString(), 
					SystemInformation.ToolWindowCaptionHeight.ToString(), 
					SystemInformation.UserDomainName.ToString(), 
					SystemInformation.UserInteractive.ToString(), 
					SystemInformation.UserName.ToString(), 
					SystemInformation.VerticalScrollBarArrowHeight.ToString(), 
					SystemInformation.VerticalScrollBarThumbHeight.ToString(), 
					SystemInformation.VerticalScrollBarWidth.ToString(), 
					SystemInformation.VirtualScreen.ToString(), 
					SystemInformation.WorkingArea.ToString() 
				}; // End of Array property Values
			} // End of get
		} // end of property Values
	
		// .    
		public static int Count
		{
			get
			{
				return Labels.Length;
			}
		}
	
		//    
		//   
		private static Single MaxWidth(String[] strArray,
			Graphics graphics, Font font)
		{
			Single fMax = 0;
			foreach(String str in strArray)
				fMax = Math.Max(fMax, graphics.MeasureString(str, font).Width);
			return fMax;
		}
	
		// ,      
		public static Single MaxLabelWidth(Graphics graphics, Font font)
		{
			return MaxWidth(Labels, graphics, font);
		}
	
		// ,      
		public static Single MaxValueWidth(Graphics graphics, Font font)
		{
			return MaxWidth(Values, graphics, font);
		}
	} // End of class SysInfoStrings
} // End of namespace Test
