using Microsoft.Win32;
using System;
using System.Windows.Forms;
using System.Drawing;
	
namespace Test
{
	public class SysInfoUpdate : Form
	{
		// - ,    - 
		protected Single xCol;
		protected int linespacing, count;
		protected String[] strArrayLabels, strArrayValues;
	
		public SysInfoUpdate()
		{
			//   
			this.Text = "   ";
			this.BackColor = SystemColors.Window;
			this.ForeColor = SystemColors.WindowText;
			this.AutoScroll = true;//    
	
			//  () 
			SystemEvents.UserPreferenceChanged
				+=new UserPreferenceChangedEventHandler(SystemEvents_UserPreferenceChanged);
			SystemEvents.DisplaySettingsChanged
				+=new EventHandler(SystemEvents_DisplaySettingsChanged);
	
			UpdateAllInfo(); //  ,  !
		}
	
		private void SystemEvents_UserPreferenceChanged(object sender, UserPreferenceChangedEventArgs e)
		{
			UpdateAllInfo();
			this.Invalidate();
		}
	
		private void SystemEvents_DisplaySettingsChanged(object sender, EventArgs e)
		{
			UpdateAllInfo();
			this.Invalidate();
		}
	
		private void UpdateAllInfo()
		{
			//     
			count = SysInfoStrings.Count;
			//      
			strArrayLabels = SysInfoStrings.Labels;
			strArrayValues = SysInfoStrings.Values;
	
			//  ,  
			Graphics gr = this.CreateGraphics();
			//   
			SizeF sizeF = gr.MeasureString(" ", Font);
			//    
			xCol = sizeF.Width 
				+ SysInfoStrings.MaxLabelWidth(gr, Font);
			linespacing = Font.Height;
	
			//   
			SizeF size_F = new SizeF(
				xCol + SysInfoStrings.MaxValueWidth(gr, Font),
				linespacing * count);
			//   
			this.AutoScrollMinSize = Size.Ceiling(size_F);
	
			//      
			gr.Dispose();
		}
	
		protected override void OnPaint(PaintEventArgs e)
		{
			Graphics gr = e.Graphics;
			SolidBrush brush = new SolidBrush(this.ForeColor);
	
			Point point = this.AutoScrollPosition; //   
			for(int i = 0; i < count; i++)
			{
				gr.DrawString(strArrayLabels[i],
					Font, brush,
					point.X, point.Y + i * linespacing);
				gr.DrawString(strArrayValues[i],
					Font, brush, 
					point.X + xCol, point.Y + i * linespacing);
			}
	
			base.OnPaint (e);
		}
	}
}
